# coding: utf-8

"""
    Allegro REST API

    https://developer.allegro.pl/about  # noqa: E501

    OpenAPI spec version: latest
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from allegro_api.api_client import ApiClient


class AdditionalServicesApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def create_additional_services_group_using_post(self, additional_services_group_request, **kwargs):  # noqa: E501
        """Create additional services group  # noqa: E501

        Use this resource to create a group of additional services. More information about this resource you can find <a href=\"../../news/2017-10-25-news_uslugi_dodatkowe/#2\" target=\"_blank\">here</a>.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_additional_services_group_using_post(additional_services_group_request, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param AdditionalServicesGroupRequest additional_services_group_request: Additional service group body (required)
        :return: AdditionalServicesGroupResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_additional_services_group_using_post_with_http_info(additional_services_group_request, **kwargs)  # noqa: E501
        else:
            (data) = self.create_additional_services_group_using_post_with_http_info(additional_services_group_request, **kwargs)  # noqa: E501
            return data

    def create_additional_services_group_using_post_with_http_info(self, additional_services_group_request, **kwargs):  # noqa: E501
        """Create additional services group  # noqa: E501

        Use this resource to create a group of additional services. More information about this resource you can find <a href=\"../../news/2017-10-25-news_uslugi_dodatkowe/#2\" target=\"_blank\">here</a>.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_additional_services_group_using_post_with_http_info(additional_services_group_request, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param AdditionalServicesGroupRequest additional_services_group_request: Additional service group body (required)
        :return: AdditionalServicesGroupResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['additional_services_group_request']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_additional_services_group_using_post" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'additional_services_group_request' is set
        if ('additional_services_group_request' not in local_var_params or
                local_var_params['additional_services_group_request'] is None):
            raise ValueError("Missing the required parameter `additional_services_group_request` when calling `create_additional_services_group_using_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'additional_services_group_request' in local_var_params:
            body_params = local_var_params['additional_services_group_request']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/vnd.allegro.public.v1+json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/vnd.allegro.public.v1+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearer-token-for-user']  # noqa: E501

        return self.api_client.call_api(
            '/sale/offer-additional-services/groups', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='AdditionalServicesGroupResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_additional_services_group_using_get(self, group_id, **kwargs):  # noqa: E501
        """Get the details of an additional services group  # noqa: E501

        Use this resource to get additional services group for a given ID. More information about this resource you can find <a href=\"../../news/2017-10-25-news_uslugi_dodatkowe/#5\" target=\"_blank\">here</a>.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_additional_services_group_using_get(group_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str group_id: Additional Service Group ID (required)
        :return: AdditionalServicesGroupResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_additional_services_group_using_get_with_http_info(group_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_additional_services_group_using_get_with_http_info(group_id, **kwargs)  # noqa: E501
            return data

    def get_additional_services_group_using_get_with_http_info(self, group_id, **kwargs):  # noqa: E501
        """Get the details of an additional services group  # noqa: E501

        Use this resource to get additional services group for a given ID. More information about this resource you can find <a href=\"../../news/2017-10-25-news_uslugi_dodatkowe/#5\" target=\"_blank\">here</a>.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_additional_services_group_using_get_with_http_info(group_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str group_id: Additional Service Group ID (required)
        :return: AdditionalServicesGroupResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['group_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_additional_services_group_using_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'group_id' is set
        if ('group_id' not in local_var_params or
                local_var_params['group_id'] is None):
            raise ValueError("Missing the required parameter `group_id` when calling `get_additional_services_group_using_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'group_id' in local_var_params:
            path_params['groupId'] = local_var_params['group_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/vnd.allegro.public.v1+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearer-token-for-user']  # noqa: E501

        return self.api_client.call_api(
            '/sale/offer-additional-services/groups/{groupId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='AdditionalServicesGroupResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_list_of_additional_services_definitions_using_get(self, user_id, **kwargs):  # noqa: E501
        """Get the user's additional services definitions  # noqa: E501

        Use this resource to get additional services definitions by user ID. More information about this resource you can find <a href=\"../../news/2017-10-25-news_uslugi_dodatkowe/#1\" target=\"_blank\">here</a>.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_list_of_additional_services_definitions_using_get(user_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str user_id: User ID (required)
        :param int offset: offset
        :param int limit: limit
        :return: DefinitionsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_list_of_additional_services_definitions_using_get_with_http_info(user_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_list_of_additional_services_definitions_using_get_with_http_info(user_id, **kwargs)  # noqa: E501
            return data

    def get_list_of_additional_services_definitions_using_get_with_http_info(self, user_id, **kwargs):  # noqa: E501
        """Get the user's additional services definitions  # noqa: E501

        Use this resource to get additional services definitions by user ID. More information about this resource you can find <a href=\"../../news/2017-10-25-news_uslugi_dodatkowe/#1\" target=\"_blank\">here</a>.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_list_of_additional_services_definitions_using_get_with_http_info(user_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str user_id: User ID (required)
        :param int offset: offset
        :param int limit: limit
        :return: DefinitionsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['user_id', 'offset', 'limit']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_list_of_additional_services_definitions_using_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'user_id' is set
        if ('user_id' not in local_var_params or
                local_var_params['user_id'] is None):
            raise ValueError("Missing the required parameter `user_id` when calling `get_list_of_additional_services_definitions_using_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'offset' in local_var_params:
            query_params.append(('offset', local_var_params['offset']))  # noqa: E501
        if 'limit' in local_var_params:
            query_params.append(('limit', local_var_params['limit']))  # noqa: E501
        if 'user_id' in local_var_params:
            query_params.append(('user.id', local_var_params['user_id']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/vnd.allegro.public.v1+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearer-token-for-user']  # noqa: E501

        return self.api_client.call_api(
            '/sale/offer-additional-services/definitions', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='DefinitionsResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_list_of_additional_services_groups_using_get(self, user_id, **kwargs):  # noqa: E501
        """Get the user's additional services groups  # noqa: E501

        Use this resource to retrieve a list of groups with additional services available to a given user which you may assign to offers. More information about this resource you can find <a href=\"../../news/2017-10-25-news_uslugi_dodatkowe/#4\" target=\"_blank\">here</a>.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_list_of_additional_services_groups_using_get(user_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str user_id: User ID (required)
        :param int offset: offset
        :param int limit: limit
        :return: AdditionalServicesGroups
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_list_of_additional_services_groups_using_get_with_http_info(user_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_list_of_additional_services_groups_using_get_with_http_info(user_id, **kwargs)  # noqa: E501
            return data

    def get_list_of_additional_services_groups_using_get_with_http_info(self, user_id, **kwargs):  # noqa: E501
        """Get the user's additional services groups  # noqa: E501

        Use this resource to retrieve a list of groups with additional services available to a given user which you may assign to offers. More information about this resource you can find <a href=\"../../news/2017-10-25-news_uslugi_dodatkowe/#4\" target=\"_blank\">here</a>.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_list_of_additional_services_groups_using_get_with_http_info(user_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str user_id: User ID (required)
        :param int offset: offset
        :param int limit: limit
        :return: AdditionalServicesGroups
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['user_id', 'offset', 'limit']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_list_of_additional_services_groups_using_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'user_id' is set
        if ('user_id' not in local_var_params or
                local_var_params['user_id'] is None):
            raise ValueError("Missing the required parameter `user_id` when calling `get_list_of_additional_services_groups_using_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'offset' in local_var_params:
            query_params.append(('offset', local_var_params['offset']))  # noqa: E501
        if 'limit' in local_var_params:
            query_params.append(('limit', local_var_params['limit']))  # noqa: E501
        if 'user_id' in local_var_params:
            query_params.append(('user.id', local_var_params['user_id']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/vnd.allegro.public.v1+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearer-token-for-user']  # noqa: E501

        return self.api_client.call_api(
            '/sale/offer-additional-services/groups', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='AdditionalServicesGroups',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def modify_additional_services_group_using_put(self, group_id, additional_services_group_request, **kwargs):  # noqa: E501
        """Modify an additional services group  # noqa: E501

        Use this resource to modify existing additional service group. More information about this resource you can find <a href=\"../../news/2017-10-25-news_uslugi_dodatkowe/#3\" target=\"_blank\">here</a>.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.modify_additional_services_group_using_put(group_id, additional_services_group_request, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str group_id: additional service group ID (required)
        :param AdditionalServicesGroupRequest additional_services_group_request: Additional service group body (required)
        :return: AdditionalServicesGroupResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.modify_additional_services_group_using_put_with_http_info(group_id, additional_services_group_request, **kwargs)  # noqa: E501
        else:
            (data) = self.modify_additional_services_group_using_put_with_http_info(group_id, additional_services_group_request, **kwargs)  # noqa: E501
            return data

    def modify_additional_services_group_using_put_with_http_info(self, group_id, additional_services_group_request, **kwargs):  # noqa: E501
        """Modify an additional services group  # noqa: E501

        Use this resource to modify existing additional service group. More information about this resource you can find <a href=\"../../news/2017-10-25-news_uslugi_dodatkowe/#3\" target=\"_blank\">here</a>.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.modify_additional_services_group_using_put_with_http_info(group_id, additional_services_group_request, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str group_id: additional service group ID (required)
        :param AdditionalServicesGroupRequest additional_services_group_request: Additional service group body (required)
        :return: AdditionalServicesGroupResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['group_id', 'additional_services_group_request']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method modify_additional_services_group_using_put" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'group_id' is set
        if ('group_id' not in local_var_params or
                local_var_params['group_id'] is None):
            raise ValueError("Missing the required parameter `group_id` when calling `modify_additional_services_group_using_put`")  # noqa: E501
        # verify the required parameter 'additional_services_group_request' is set
        if ('additional_services_group_request' not in local_var_params or
                local_var_params['additional_services_group_request'] is None):
            raise ValueError("Missing the required parameter `additional_services_group_request` when calling `modify_additional_services_group_using_put`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'group_id' in local_var_params:
            path_params['groupId'] = local_var_params['group_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'additional_services_group_request' in local_var_params:
            body_params = local_var_params['additional_services_group_request']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/vnd.allegro.public.v1+json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/vnd.allegro.public.v1+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearer-token-for-user']  # noqa: E501

        return self.api_client.call_api(
            '/sale/offer-additional-services/groups/{groupId}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='AdditionalServicesGroupResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)
