# coding: utf-8

"""
    Allegro REST API

    https://developer.allegro.pl/about  # noqa: E501

    OpenAPI spec version: latest
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from allegro_api.api_client import ApiClient


class DeliveryApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def create_shipping_rates_set_using_post(self, shipping_rates_set, **kwargs):  # noqa: E501
        """Create a new shipping rates set  # noqa: E501

        Use this resource to create a new seller's shipping rates set. More information about this resource you can find <a href=\"../news/2018-08-14-cenniki_dostawy/\" target=\"_blank\">here</a>.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_shipping_rates_set_using_post(shipping_rates_set, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ShippingRatesSet shipping_rates_set: Shipping rates set (required)
        :return: ShippingRatesSet
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_shipping_rates_set_using_post_with_http_info(shipping_rates_set, **kwargs)  # noqa: E501
        else:
            (data) = self.create_shipping_rates_set_using_post_with_http_info(shipping_rates_set, **kwargs)  # noqa: E501
            return data

    def create_shipping_rates_set_using_post_with_http_info(self, shipping_rates_set, **kwargs):  # noqa: E501
        """Create a new shipping rates set  # noqa: E501

        Use this resource to create a new seller's shipping rates set. More information about this resource you can find <a href=\"../news/2018-08-14-cenniki_dostawy/\" target=\"_blank\">here</a>.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_shipping_rates_set_using_post_with_http_info(shipping_rates_set, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ShippingRatesSet shipping_rates_set: Shipping rates set (required)
        :return: ShippingRatesSet
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['shipping_rates_set']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_shipping_rates_set_using_post" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'shipping_rates_set' is set
        if ('shipping_rates_set' not in local_var_params or
                local_var_params['shipping_rates_set'] is None):
            raise ValueError("Missing the required parameter `shipping_rates_set` when calling `create_shipping_rates_set_using_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'shipping_rates_set' in local_var_params:
            body_params = local_var_params['shipping_rates_set']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/vnd.allegro.public.v1+json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/vnd.allegro.public.v1+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearer-token-for-user']  # noqa: E501

        return self.api_client.call_api(
            '/sale/shipping-rates', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ShippingRatesSet',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_list_of_delivery_methods_using_get(self, **kwargs):  # noqa: E501
        """Get the list of available delivery methods  # noqa: E501

        Use this resource to get a list of available delivery methods. More information about this resource you can find <a href=\"../news/2018-08-14-cenniki_dostawy/\" target=\"_blank\">here</a>.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_list_of_delivery_methods_using_get(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: InlineResponse2001
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_list_of_delivery_methods_using_get_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_list_of_delivery_methods_using_get_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_list_of_delivery_methods_using_get_with_http_info(self, **kwargs):  # noqa: E501
        """Get the list of available delivery methods  # noqa: E501

        Use this resource to get a list of available delivery methods. More information about this resource you can find <a href=\"../news/2018-08-14-cenniki_dostawy/\" target=\"_blank\">here</a>.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_list_of_delivery_methods_using_get_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: InlineResponse2001
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = []  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_list_of_delivery_methods_using_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/vnd.allegro.public.v1+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearer-token-for-application', 'bearer-token-for-user']  # noqa: E501

        return self.api_client.call_api(
            '/sale/delivery-methods', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2001',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_list_of_shipping_ratest_using_get(self, seller_id, **kwargs):  # noqa: E501
        """Get the user's shipping rates  # noqa: E501

        Use this resource to get a list of seller's shipping rates. More information about this resource you can find <a href=\"../news/2018-08-14-cenniki_dostawy/\" target=\"_blank\">here</a>.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_list_of_shipping_ratest_using_get(seller_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str seller_id: id of shipping rates owner (required)
        :return: InlineResponse200
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_list_of_shipping_ratest_using_get_with_http_info(seller_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_list_of_shipping_ratest_using_get_with_http_info(seller_id, **kwargs)  # noqa: E501
            return data

    def get_list_of_shipping_ratest_using_get_with_http_info(self, seller_id, **kwargs):  # noqa: E501
        """Get the user's shipping rates  # noqa: E501

        Use this resource to get a list of seller's shipping rates. More information about this resource you can find <a href=\"../news/2018-08-14-cenniki_dostawy/\" target=\"_blank\">here</a>.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_list_of_shipping_ratest_using_get_with_http_info(seller_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str seller_id: id of shipping rates owner (required)
        :return: InlineResponse200
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['seller_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_list_of_shipping_ratest_using_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'seller_id' is set
        if ('seller_id' not in local_var_params or
                local_var_params['seller_id'] is None):
            raise ValueError("Missing the required parameter `seller_id` when calling `get_list_of_shipping_ratest_using_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'seller_id' in local_var_params:
            query_params.append(('seller.id', local_var_params['seller_id']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/vnd.allegro.public.v1+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearer-token-for-user']  # noqa: E501

        return self.api_client.call_api(
            '/sale/shipping-rates', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse200',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_shipping_rates_set_using_get(self, id, **kwargs):  # noqa: E501
        """Get the details of a shipping rates set  # noqa: E501

        Use this resource to get details of the given shipping rates set. More information about this resource you can find <a href=\"../news/2018-08-14-cenniki_dostawy\" target=\"_blank\">here</a>.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_shipping_rates_set_using_get(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str id: id of shipping rates set (required)
        :return: ShippingRatesSet
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_shipping_rates_set_using_get_with_http_info(id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_shipping_rates_set_using_get_with_http_info(id, **kwargs)  # noqa: E501
            return data

    def get_shipping_rates_set_using_get_with_http_info(self, id, **kwargs):  # noqa: E501
        """Get the details of a shipping rates set  # noqa: E501

        Use this resource to get details of the given shipping rates set. More information about this resource you can find <a href=\"../news/2018-08-14-cenniki_dostawy\" target=\"_blank\">here</a>.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_shipping_rates_set_using_get_with_http_info(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str id: id of shipping rates set (required)
        :return: ShippingRatesSet
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_shipping_rates_set_using_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in local_var_params or
                local_var_params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `get_shipping_rates_set_using_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'id' in local_var_params:
            path_params['id'] = local_var_params['id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/vnd.allegro.public.v1+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearer-token-for-user']  # noqa: E501

        return self.api_client.call_api(
            '/sale/shipping-rates/{id}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ShippingRatesSet',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def modify_shipiing_rates_set_using_put(self, id, shipping_rates_set, **kwargs):  # noqa: E501
        """Edit a user's shipping rates set  # noqa: E501

        Use this resource to edit a new seller's shipping rates set. More information about this resource you can find <a href=\"../news/2018-08-14-cenniki_dostawy/\" target=\"_blank\">here</a>.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.modify_shipiing_rates_set_using_put(id, shipping_rates_set, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str id: id of shipping rates set (required)
        :param ShippingRatesSet shipping_rates_set: Shipping rates set (required)
        :return: ShippingRatesSet
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.modify_shipiing_rates_set_using_put_with_http_info(id, shipping_rates_set, **kwargs)  # noqa: E501
        else:
            (data) = self.modify_shipiing_rates_set_using_put_with_http_info(id, shipping_rates_set, **kwargs)  # noqa: E501
            return data

    def modify_shipiing_rates_set_using_put_with_http_info(self, id, shipping_rates_set, **kwargs):  # noqa: E501
        """Edit a user's shipping rates set  # noqa: E501

        Use this resource to edit a new seller's shipping rates set. More information about this resource you can find <a href=\"../news/2018-08-14-cenniki_dostawy/\" target=\"_blank\">here</a>.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.modify_shipiing_rates_set_using_put_with_http_info(id, shipping_rates_set, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str id: id of shipping rates set (required)
        :param ShippingRatesSet shipping_rates_set: Shipping rates set (required)
        :return: ShippingRatesSet
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['id', 'shipping_rates_set']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method modify_shipiing_rates_set_using_put" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in local_var_params or
                local_var_params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `modify_shipiing_rates_set_using_put`")  # noqa: E501
        # verify the required parameter 'shipping_rates_set' is set
        if ('shipping_rates_set' not in local_var_params or
                local_var_params['shipping_rates_set'] is None):
            raise ValueError("Missing the required parameter `shipping_rates_set` when calling `modify_shipiing_rates_set_using_put`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'id' in local_var_params:
            path_params['id'] = local_var_params['id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'shipping_rates_set' in local_var_params:
            body_params = local_var_params['shipping_rates_set']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/vnd.allegro.public.v1+json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/vnd.allegro.public.v1+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearer-token-for-user']  # noqa: E501

        return self.api_client.call_api(
            '/sale/shipping-rates/{id}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ShippingRatesSet',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)
