# coding: utf-8

"""
    Allegro REST API

    https://developer.allegro.pl/about  # noqa: E501

    OpenAPI spec version: latest
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from allegro_api.api_client import ApiClient


class ProductsApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_sale_product(self, product_id, **kwargs):  # noqa: E501
        """Get all data of the particular product  # noqa: E501

        Use this resource to retrieve all data of the particular product.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_sale_product(product_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str product_id: Product identifier (required)
        :return: SaleProductResponseDto
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_sale_product_with_http_info(product_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_sale_product_with_http_info(product_id, **kwargs)  # noqa: E501
            return data

    def get_sale_product_with_http_info(self, product_id, **kwargs):  # noqa: E501
        """Get all data of the particular product  # noqa: E501

        Use this resource to retrieve all data of the particular product.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_sale_product_with_http_info(product_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str product_id: Product identifier (required)
        :return: SaleProductResponseDto
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['product_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_sale_product" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'product_id' is set
        if ('product_id' not in local_var_params or
                local_var_params['product_id'] is None):
            raise ValueError("Missing the required parameter `product_id` when calling `get_sale_product`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'product_id' in local_var_params:
            path_params['productId'] = local_var_params['product_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/vnd.allegro.beta.v1+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearer-token-for-user']  # noqa: E501

        return self.api_client.call_api(
            '/sale/products/{productId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SaleProductResponseDto',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_sale_products(self, **kwargs):  # noqa: E501
        """Get search products results  # noqa: E501

        Use this resource to get a list of products according to provided parameters. At least ean parameter is required.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_sale_products(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str ean: The EAN values can include EAN, ISBN, and UPC identifier types.
        :return: GetSaleProductsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_sale_products_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_sale_products_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_sale_products_with_http_info(self, **kwargs):  # noqa: E501
        """Get search products results  # noqa: E501

        Use this resource to get a list of products according to provided parameters. At least ean parameter is required.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_sale_products_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str ean: The EAN values can include EAN, ISBN, and UPC identifier types.
        :return: GetSaleProductsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['ean']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_sale_products" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']

        if ('ean' in local_var_params and
                len(local_var_params['ean']) > 18):
            raise ValueError("Invalid value for parameter `ean` when calling `get_sale_products`, length must be less than or equal to `18`")  # noqa: E501
        collection_formats = {}

        path_params = {}

        query_params = []
        if 'ean' in local_var_params:
            query_params.append(('ean', local_var_params['ean']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/vnd.allegro.beta.v1+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearer-token-for-user']  # noqa: E501

        return self.api_client.call_api(
            '/sale/products', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='GetSaleProductsResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)
