# coding: utf-8

"""
    Allegro REST API

    https://developer.allegro.pl/about  # noqa: E501

    OpenAPI spec version: latest
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class CheckoutFormBuyerReference(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'str',
        'email': 'str',
        'login': 'str',
        'guest': 'bool',
        'personal_identity': 'str',
        'phone_number': 'str'
    }

    attribute_map = {
        'id': 'id',
        'email': 'email',
        'login': 'login',
        'guest': 'guest',
        'personal_identity': 'personalIdentity',
        'phone_number': 'phoneNumber'
    }

    def __init__(self, id=None, email=None, login=None, guest=None, personal_identity=None, phone_number=None):  # noqa: E501
        """CheckoutFormBuyerReference - a model defined in OpenAPI"""  # noqa: E501

        self._id = None
        self._email = None
        self._login = None
        self._guest = None
        self._personal_identity = None
        self._phone_number = None
        self.discriminator = None

        self.id = id
        self.email = email
        self.login = login
        self.guest = guest
        if personal_identity is not None:
            self.personal_identity = personal_identity
        if phone_number is not None:
            self.phone_number = phone_number

    @property
    def id(self):
        """Gets the id of this CheckoutFormBuyerReference.  # noqa: E501

        buyer id  # noqa: E501

        :return: The id of this CheckoutFormBuyerReference.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CheckoutFormBuyerReference.

        buyer id  # noqa: E501

        :param id: The id of this CheckoutFormBuyerReference.  # noqa: E501
        :type: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def email(self):
        """Gets the email of this CheckoutFormBuyerReference.  # noqa: E501


        :return: The email of this CheckoutFormBuyerReference.  # noqa: E501
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email):
        """Sets the email of this CheckoutFormBuyerReference.


        :param email: The email of this CheckoutFormBuyerReference.  # noqa: E501
        :type: str
        """
        if email is None:
            raise ValueError("Invalid value for `email`, must not be `None`")  # noqa: E501

        self._email = email

    @property
    def login(self):
        """Gets the login of this CheckoutFormBuyerReference.  # noqa: E501


        :return: The login of this CheckoutFormBuyerReference.  # noqa: E501
        :rtype: str
        """
        return self._login

    @login.setter
    def login(self, login):
        """Sets the login of this CheckoutFormBuyerReference.


        :param login: The login of this CheckoutFormBuyerReference.  # noqa: E501
        :type: str
        """
        if login is None:
            raise ValueError("Invalid value for `login`, must not be `None`")  # noqa: E501

        self._login = login

    @property
    def guest(self):
        """Gets the guest of this CheckoutFormBuyerReference.  # noqa: E501

        is a guest account?  # noqa: E501

        :return: The guest of this CheckoutFormBuyerReference.  # noqa: E501
        :rtype: bool
        """
        return self._guest

    @guest.setter
    def guest(self, guest):
        """Sets the guest of this CheckoutFormBuyerReference.

        is a guest account?  # noqa: E501

        :param guest: The guest of this CheckoutFormBuyerReference.  # noqa: E501
        :type: bool
        """
        if guest is None:
            raise ValueError("Invalid value for `guest`, must not be `None`")  # noqa: E501

        self._guest = guest

    @property
    def personal_identity(self):
        """Gets the personal_identity of this CheckoutFormBuyerReference.  # noqa: E501

        Buyer's personal identity number (PESEL)  # noqa: E501

        :return: The personal_identity of this CheckoutFormBuyerReference.  # noqa: E501
        :rtype: str
        """
        return self._personal_identity

    @personal_identity.setter
    def personal_identity(self, personal_identity):
        """Sets the personal_identity of this CheckoutFormBuyerReference.

        Buyer's personal identity number (PESEL)  # noqa: E501

        :param personal_identity: The personal_identity of this CheckoutFormBuyerReference.  # noqa: E501
        :type: str
        """

        self._personal_identity = personal_identity

    @property
    def phone_number(self):
        """Gets the phone_number of this CheckoutFormBuyerReference.  # noqa: E501

        Phone number  # noqa: E501

        :return: The phone_number of this CheckoutFormBuyerReference.  # noqa: E501
        :rtype: str
        """
        return self._phone_number

    @phone_number.setter
    def phone_number(self, phone_number):
        """Sets the phone_number of this CheckoutFormBuyerReference.

        Phone number  # noqa: E501

        :param phone_number: The phone_number of this CheckoutFormBuyerReference.  # noqa: E501
        :type: str
        """

        self._phone_number = phone_number

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CheckoutFormBuyerReference):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
